<template>
  <form class="form-inline mb-2">
    {{ range }}. (Total count: {{ totalItems }}). Items per page:&nbsp;
    <select
      class="custom-select custom-select-sm"
      :value="perPage"
      @change="$emit('perPage', $event.target.value)"
    >
      <option v-for="size in $options.sizes" :value="size">
        {{ size }}
      </option>
    </select>
    &nbsp;
    <template v-if="totalPages > 1"
      >– Current Page:&nbsp;
      <nav>
        <ul class="pagination pagination-sm mb-0">
          <li class="page-item" :class="{ disabled: page === 1 }">
            <a
              class="page-link"
              href="#"
              aria-label="Previous"
              @click.prevent="$emit('page', page - 1)"
            >
              <span aria-hidden="true">&laquo;</span>
            </a>
          </li>
          <li
            class="page-item"
            :class="{ disabled: !Number.isInteger(p), active: page === p }"
            v-for="p in renderedPages"
          >
            <a class="page-link" href="#" @click.prevent="$emit('page', p)">
              {{ p }}
            </a>
          </li>
          <li class="page-item" :class="{ disabled: page === totalPages }">
            <a
              class="page-link"
              href="#"
              aria-label="Next"
              @click.prevent="$emit('page', page + 1)"
            >
              <span aria-hidden="true">&raquo;</span>
            </a>
          </li>
        </ul>
      </nav>
    </template>
  </form>
</template>
<script>
export default {
  sizes: [100, 250, 500, 1000],
  name: "pagination",
  props: {
    itemCount: {},
    page: {
      default: 1,
    },
    perPage: {},
    totalItems: {},
  },
  watch: {
    totalPages(newValue) {
      if (this.page > newValue) {
        this.$emit("page", newValue);
      }
    },
  },
  computed: {
    range() {
      if (this.itemCount < this.perPage) {
        return `Showing items ${this.itemCount} filtered items`;
      }
      const start = (this.page - 1) * this.perPage + 1;
      const end = Math.min(this.itemCount, this.perPage * this.page);
      return `Showing items ${start} to ${end} of ${this.itemCount} filtered items`;
    },
    totalPages() {
      return Math.ceil(this.itemCount / this.perPage);
    },
    renderedPages() {
      const pages = [];
      for (let i = 2; i < this.totalPages; i += 1) {
        if (Math.abs(this.page - i) < 4) {
          pages.push(i);
        }
      }
      pages.unshift(1);
      pages.push(this.totalPages);
      if (!pages.includes(2)) {
        pages.shift();
        pages.unshift(1, "...");
      }
      if (!pages.includes(this.totalPages - 1)) {
        pages.pop();
        pages.push("...", this.totalPages);
      }
      return pages;
    },
  },
};
</script>
